var Router = (function () {
    function Router() {
        this.routes = new Array();
    }
    Router.prototype.addRoute = function (route) {
        this.routes.push(route);
    };
    Router.prototype.addRoutes = function (routes) {
        for (var _i = 0, routes_1 = routes; _i < routes_1.length; _i++) {
            var route = routes_1[_i];
            this.addRoute(route);
        }
    };
    Router.prototype.getRoute = function (path) {
        for (var _i = 0, _a = this.routes; _i < _a.length; _i++) {
            var route = _a[_i];
            if (route.path === path) {
                return route;
            }
        }
        throw new Error("ROUTE_NOT_FOUND");
    };
    Router.prototype.routeTo = function (path) {
        for (var _i = 0, _a = this.routes; _i < _a.length; _i++) {
            var route = _a[_i];
            if (route.path === path) {
                this.switchPage(route.page);
            }
        }
    };
    Router.prototype.switchPage = function (targetPage) {
        var app = document.getElementById("app");
        if (app) {
            app.innerHTML = "";
            targetPage.created();
            for (var _i = 0, _a = targetPage.render(); _i < _a.length; _i++) {
                var element = _a[_i];
                app.insertBefore(element, null);
            }
            targetPage.mounted();
        }
        else {
            throw new Error("NO_APP_ELEMENT");
        }
    };
    return Router;
}());
export { Router };
var Route = (function () {
    function Route(path, page) {
        this.path = path;
        this.page = page;
    }
    return Route;
}());
export { Route };
